;###########################################
;# Projekt: 								# 
;# 											#
;#											#
;# Taktfrequenz des AVR: 4 MHz	 			#
;# 											#
;# CS-SOFT 									#
;###########################################

.include "m8def.inc"	;Atmega8

.def temp0 = r16 	; 
.def temp1 = r17 	;
.def temp2 = r18
.def temp3 = r19 	;
.def temp4 = r20
.def cnt   = r21

.equ 	ocr2s	=	$0063			;fr T2
.equ 	ocra1h	=	$0064			;;;;;
.equ 	ocra1l	=	$0065			;;;;;;;; fr T1 A channel
.equ 	ocrb1h	=	$0066			;;;;;
.equ 	ocrb1l	=	$0067			;;;;;;;; fr T1 B channel
.equ 	icr1xh	=	$0068			;;;;;
.equ 	icr1xl	=	$0069			;;;;;;;; fr T1 ICR
.equ	hadc	=	$006a			;adc
.equ	ladc	=	$006b			;adc
.equ	eep_adrh=	$006c			;eeprom
.equ	eep_adrl=	$006d			;eeprom

;***************************Einsprungadressen***********************
.cseg
.org $0000
	rjmp	stack
.org $0001			;1
	rjmp	INT_0
.org $0002			;2
	rjmp	INT_1
.org $0003			;3
	rjmp	INT_OC2
.org $0004			;4
	rjmp	INT_OVF2
.org $0005			;5
	rjmp	INT_ICP1
.org $0006			;6
	rjmp	INT_OC1A
.org $0007			;7
	rjmp	INT_OC1B
.org $0008			;8
	rjmp	INT_OVF1
.org $0009			;9
	rjmp	INT_OVF0

		reti		;a keine SPI Routinen

.org $000b			;b
	rjmp	INT_URXC
.org $000c			;c
	rjmp	INT_UDRE
.org $000d			;d
	rjmp	INT_UTXC
.org $000e			;e
	rjmp	adc_rdy
.org $000f			;f
	rjmp	eeprom_rdy
.org $0010			;10
	rjmp	ac_int

		reti		;11	keine 2wireRoutinen
		reti		;12 keine SPMRoutinen

/* so knnten die einsprungmarken der INTS auch aussehen
INT0addr	
INT1addr	
OC2addr	
OVF2addr
ICP1addr	
OC1Aaddr
OC1Baddr
OVF1addr
OVF0addr
SPIaddr
URXCaddr
UDREaddr
UTXCaddr
ADCCaddr
ERDYaddr
ACIaddr
TWIaddr
SPMRaddr
*/
;***************************Init mit allem drumdran*****************
stack:	ldi 		temp1,high(ramend)  ;Stackpointer festlegen
	    out 		sph, temp1
		ldi 		temp1,low(ramend)   ;Stackpointer festlegen
        out 		spl, temp1
		rcall		sram

		sbi			portb,0				;pulls aktivieren	
		sbi			portb,1

	;	rcall		INIT_ext_Int01
	;	rcall		deak_int01	

	;	rcall		mode0_t0_init
	;	rcall		prescaler_T0_on

	;	rcall		mode0_t1_init
	;	rcall		prescaler_T1_on

	;	rcall		mode0_t2_init
	;	rcall		prescaler_T2_on

	;	rcall		adc_header
	
	;	rcall		eeprom_init		;wenn ints bevorzugt werden	
	;	rcall		adr_cnt
	;	rcall		eeprom_write

	;	rcall		AC_init
	;	rcall		ac_change
		rcall		usart_init		;wenn INT bevorzugt dann hier aktivieren und prog erweitern 

start:	sbis		pinb,0
		rcall		tx
		sbis		pinb,1
		rcall		rx
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		rjmp		start

;************************Unterprogramme******************************
rx:		rcall		data_received	;warte auf daten von PC
		cpi			temp1,' '		;vergleich auf leerzeichen
		brne		rx				;sonst wenn falsch warte weiter
		ldi			temp1,'*'		;
		rcall		data_transmit	;sende * als ack
		ret

tx:		rcall		wait150ms
		ldi			temp1,'T'
		rcall		data_transmit	;sende T
		ldi			temp1,'S'
		rcall		data_transmit	;sende S
		ldi			temp1,'T'
		rcall		data_transmit	;sende T
		ret

;**********************Masterclr***************************************
sram:	clr			temp0
		ldi			yl,low($0060)
		ldi			yh,high($0060)			;Masterclr des Sram's ber
sram2:	st			y+,temp0				;die indirekte Adressierung
		cpi			yl,$70					;bis zur zelle x=$70 lschen
		brne		sram2		
		ret

;************************zeitschleifen******************************************
wait1us:nop
		ret

wait50us:
		ldi			temp4,$41
wait50us1:		
		dec			temp4
		brne		wait50us1		
		ret

wait58us:
		ldi			temp4,$4c
wait58us1:	
		dec			temp4
		brne		wait58us1		
		ret

wait100us:
		ldi			temp4,$83
wait100us1:
		dec			temp4
		brne		wait100us1
		ret		

wait1ms:ldi			temp3,$06
wait1ms1:
		ldi			temp4,$df
wait1ms2:
		dec			temp4
		brne		wait1ms2
		dec			temp3
		brne		wait1ms1
		ret

wait10ms:ldi		temp3,$60
wait10ms1:
		ldi			temp4,$df
wait10ms2:
		dec			temp4
		brne		wait10ms2
		dec			temp3
		brne		wait10ms1
		ret

waitxms:rcall		wait1ms
		dec			temp0
		brne		waitxms
		pop			temp2
		pop			temp1
		pop			temp0
		ret

wait150ms:
		push		temp0
		push		temp1
		push		temp2
		ldi			temp0,$96
		rjmp		waitxms

;*************************weitere*includedata***********************
/*
.include "J:\etronik\Software3\sonstiges\origin\timercounter.asm"
.include "J:\etronik\Software3\sonstiges\origin\ext_ints.asm"
.include "J:\etronik\Software3\sonstiges\origin\rs232.asm"
.include "J:\etronik\Software3\sonstiges\origin\adc_lst.asm"
.include "J:\etronik\Software3\sonstiges\origin\eeprom.asm"
.include "J:\etronik\Software3\sonstiges\origin\analogcomparator.asm"
*/
.include "timercounter.asm"
.include "ext_ints.asm"
.include "rs232.asm"
.include "adc_lst.asm"
.include "eeprom.asm"
.include "analogcomparator.asm"
;*************************ENDE**************************************
