;*****************************INIT-Mode 1 Timer0********************************************************************
mode0_t0_init:
		in			temp1,TIMSK
		ori			temp1,(1<<TOIE0)
		out			TIMSK,temp1
		ldi			temp1,$60
		out			TCNT0,temp1
		ret

prescaler_T0_on:
		in			temp0,TCCR0
		ori			temp0,(0<<CS12|0<<CS11|1<<CS10) ;schmeit den counter an
		out			TCCR0,temp0
		sei
		ret

prescaler_T0_off:
		in			temp0,TCCR0
		andi		temp0,(0<<CS12|0<<CS11|0<<CS10) ;stoppt den counter an
		out			TCCR0,temp0
		ret
	
INT_OVF0:	;$0009
		;Achtung T0 muss hier neu geladen werden und dann die eigene IDEE
		reti

;******************************Init-Modes des Timers1***************************************************************
mode0_T1_init:;NORMAL_MODE  OCR1A h:l,OCR1B h:l update ocrxH:L sofort oder im INT
		;rcall		A_ch_en						;out aktivieren
		;rcall		B_ch_en						;out aktivieren
		;rcall		A_ch_load					;Zeitwert laden
		;rcall		B_ch_load					;Zeitwert laden
		ldi			temp0,(0<<ICNC1|0<<ICES1|0<<WGM13|0<<WGM12)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1B,temp0	
		in			temp0,TCCR1A
		ori			temp0,(0<<COM1A1|0<<COM1A0|0<<COM1B1|0<<COM1B0|0<<WGM11|0<<WGM10)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1A,temp0
		in			temp0,TIMSK
		ori			temp0,(0<<TICIE1|0<<OCIE1A|0<<OCIE1B|0<<TOIE1)	;INT fr ICP=off, OCIE1A=off, OCIE1B=off, OVFL=1
		out			TIMSK,temp0						
		ret

mode1_T1_init:;8bit phase correct mode OCR1A h:l,OCR1B h:l update ocrxH:L on top oder im INT
		;rcall		A_ch_en						;out aktivieren
		;rcall		B_ch_en						;out aktivieren
		;rcall		A_ch_load					;Zeitwert laden
		;rcall		B_ch_load					;Zeitwert laden
		ldi			temp0,(0<<WGM13|0<<WGM12)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1B,temp0	
		in			temp0,TCCR1A
		ori			temp0,(1<<COM1A1|0<<COM1A0|1<<COM1B1|0<<COM1B0|0<<WGM11|1<<WGM10)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1A,temp0
		in			temp0,TIMSK
		ori			temp0,(0<<TICIE1|1<<OCIE1A|1<<OCIE1B|0<<TOIE1)	;INT fr ICP=off, OCIE1A=off, OCIE1B=off, OVFL=1
		out			TIMSK,temp0						
		ret

mode2_T1_init:;9bit phase correct mode OCR1A h:l,OCR1B h:l update ocrxH:L on top oder im INT
		;rcall		A_ch_en						;out aktivieren
		;rcall		B_ch_en						;out aktivieren
		;rcall		A_ch_load					;Zeitwert laden
		;rcall		B_ch_load					;Zeitwert laden
		ldi			temp0,(0<<WGM13|0<<WGM12)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1B,temp0	
		in			temp0,TCCR1A
		ori			temp0,(1<<COM1A1|0<<COM1A0|1<<COM1B1|0<<COM1B0|1<<WGM11|0<<WGM10)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1A,temp0
		in			temp0,TIMSK
		ori			temp0,(0<<TICIE1|1<<OCIE1A|1<<OCIE1B|0<<TOIE1)	;INT fr ICP=off, OCIE1A=off, OCIE1B=off, OVFL=1
		out			TIMSK,temp0						
		ret

mode3_T1_init:;10bit phase correct mode OCR1A h:l,OCR1B h:l update ocrxH:L on top oder im INT
		;rcall		A_ch_en						;out aktivieren
		;rcall		B_ch_en						;out aktivieren
		;rcall		A_ch_load					;Zeitwert laden
		;rcall		B_ch_load					;Zeitwert laden
		ldi			temp0,(0<<WGM13|0<<WGM12)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1B,temp0	
		in			temp0,TCCR1A
		ori			temp0,(1<<COM1A1|0<<COM1A0|1<<COM1B1|0<<COM1B0|1<<WGM11|1<<WGM10)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1A,temp0
		in			temp0,TIMSK
		ori			temp0,(0<<TICIE1|1<<OCIE1A|1<<OCIE1B|0<<TOIE1)	;INT fr ICP=off, OCIE1A=off, OCIE1B=off, OVFL=1
		out			TIMSK,temp0						
		ret

mode4_T1_init:;CTC mode OCR1A h:l,OCR1B h:l update ocrAH:L oder im INT
		;rcall		A_ch_en						;out aktivieren
		;rcall		B_ch_en						;out aktivieren
		;rcall		A_ch_load					;Zeitwert laden
		;rcall		B_ch_load					;Zeitwert laden
		ldi			temp0,(0<<WGM13|1<<WGM12)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1B,temp0	
		in			temp0,TCCR1A
		ori			temp0,(0<<COM1A1|0<<COM1A0|0<<COM1B1|0<<COM1B0|0<<WGM11|0<<WGM10)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1A,temp0
		in			temp0,TIMSK
		ori			temp0,(0<<TICIE1|0<<OCIE1A|0<<OCIE1B|0<<TOIE1)	;INT fr ICP=off, OCIE1A=off, OCIE1B=off, OVFL=1
		out			TIMSK,temp0						
		ret

mode5_T1_init:;FAST PWM 8bit OCR1A h:l,OCR1B h:l update ocrxH:L on bottom oder im INT
		;rcall		A_ch_en						;out aktivieren
		;rcall		B_ch_en						;out aktivieren
		;rcall		A_ch_load					;Zeitwert laden
		;rcall		B_ch_load					;Zeitwert laden
		ldi			temp0,(0<<WGM13|1<<WGM12)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1B,temp0	
		in			temp0,TCCR1A
		ori			temp0,(1<<COM1A1|0<<COM1A0|1<<COM1B1|0<<COM1B0|0<<WGM11|1<<WGM10)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1A,temp0
		in			temp0,TIMSK
		ori			temp0,(0<<TICIE1|1<<OCIE1A|1<<OCIE1B|0<<TOIE1)	;INT fr ICP=off, OCIE1A=off, OCIE1B=off, OVFL=1
		out			TIMSK,temp0						
		ret

mode6_T1_init:;FAST PWM 9bit OCR1A h:l,OCR1B h:l update ocrxH:L on bottom oder im INT
		;rcall		A_ch_en						;out aktivieren
		;rcall		B_ch_en						;out aktivieren
		;rcall		A_ch_load					;Zeitwert laden
		;rcall		B_ch_load					;Zeitwert laden
		ldi			temp0,(0<<WGM13|1<<WGM12)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1B,temp0	
		in			temp0,TCCR1A
		ori			temp0,(1<<COM1A1|0<<COM1A0|1<<COM1B1|0<<COM1B0|1<<WGM11|0<<WGM10)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1A,temp0
		in			temp0,TIMSK
		ori			temp0,(0<<TICIE1|1<<OCIE1A|1<<OCIE1B|0<<TOIE1)	;INT fr ICP=off, OCIE1A=off, OCIE1B=off, OVFL=1
		out			TIMSK,temp0						
		ret

mode7_T1_init:;FAST PWM 10bit OCR1A h:l,OCR1B h:l update ocrxH:L on bottom oder im INT
		;rcall		A_ch_en						;out aktivieren
		;rcall		B_ch_en						;out aktivieren
		;rcall		A_ch_load					;Zeitwert laden
		;rcall		B_ch_load					;Zeitwert laden
		ldi			temp0,(0<<WGM13|1<<WGM12)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1B,temp0	
		in			temp0,TCCR1A
		ori			temp0,(1<<COM1A1|0<<COM1A0|1<<COM1B1|0<<COM1B0|1<<WGM11|1<<WGM10)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1A,temp0
		in			temp0,TIMSK
		ori			temp0,(0<<TICIE1|1<<OCIE1A|1<<OCIE1B|0<<TOIE1)	;INT fr ICP=off, OCIE1A=off, OCIE1B=off, OVFL=1
		out			TIMSK,temp0						
		ret

mode8_T1_init:;PWM,PahseFrequenzyCorrect OCR1A h:l,ICRh:l update ocrxH:L on bottom oder im INT
		;rcall		A_ch_en						;out aktivieren
		;rcall		B_ch_en						;out aktivieren
		;rcall		A_ch_load					;Zeitwert laden
		;rcall		B_ch_load					;Zeitwert laden
		ldi			temp0,(1<<ICES1|1<<WGM13|0<<WGM12)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1B,temp0	
		in			temp0,TCCR1A
		ori			temp0,(1<<COM1A1|0<<COM1A0|1<<COM1B1|0<<COM1B0|0<<WGM11|0<<WGM10)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1A,temp0
		in			temp0,TIMSK
		ori			temp0,(1<<TICIE1|0<<OCIE1A|0<<OCIE1B|0<<TOIE1)	;INT fr ICP=off, OCIE1A=off, OCIE1B=off, OVFL=1
		out			TIMSK,temp0						
		ret

mode9_T1_init:;PWM,PahseFrequenzyCorrect OCR1A h:l,OCR1A h:l update ocrxH:L on bottom oder im INT
		;rcall		A_ch_en						;out aktivieren
		;rcall		B_ch_en						;out aktivieren
		;rcall		A_ch_load					;Zeitwert laden
		;rcall		B_ch_load					;Zeitwert laden
		ldi			temp0,(1<<WGM13|0<<WGM12)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1B,temp0	
		in			temp0,TCCR1A
		ori			temp0,(1<<COM1A1|0<<COM1A0|1<<COM1B1|0<<COM1B0|0<<WGM11|1<<WGM10)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1A,temp0
		in			temp0,TIMSK
		ori			temp0,(0<<TICIE1|1<<OCIE1A|1<<OCIE1B|0<<TOIE1)	;INT fr ICP=off, OCIE1A=off, OCIE1B=off, OVFL=1
		out			TIMSK,temp0						
		ret

mode10_T1_init:;PWM,PahseCorrect OCR1A h:l,ICRh:l update ocrxH:L on top oder im INT
		;rcall		A_ch_en						;out aktivieren
		;rcall		B_ch_en						;out aktivieren
		;rcall		A_ch_load					;Zeitwert laden
		;rcall		B_ch_load					;Zeitwert laden
		ldi			temp0,(1<<WGM13|0<<WGM12)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1B,temp0	
		in			temp0,TCCR1A
		ori			temp0,(1<<COM1A1|0<<COM1A0|1<<COM1B1|0<<COM1B0|1<<WGM11|0<<WGM10)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1A,temp0
		in			temp0,TIMSK
		ori			temp0,(1<<TICIE1|0<<OCIE1A|0<<OCIE1B|0<<TOIE1)	;INT fr ICP=off, OCIE1A=off, OCIE1B=off, OVFL=1
		out			TIMSK,temp0						
		ret

mode11_T1_init:;PWM,PahseCorrect OCR1A h:l,OCRah:l update ocrxH:L on top oder im INT
		;rcall		A_ch_en						;out aktivieren
		;rcall		B_ch_en						;out aktivieren
		;rcall		A_ch_load					;Zeitwert laden
		;rcall		B_ch_load					;Zeitwert laden
		ldi			temp0,(1<<WGM13|0<<WGM12)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1B,temp0	
		in			temp0,TCCR1A
		ori			temp0,(1<<COM1A1|0<<COM1A0|1<<COM1B1|0<<COM1B0|1<<WGM11|1<<WGM10)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1A,temp0
		in			temp0,TIMSK
		ori			temp0,(0<<TICIE1|1<<OCIE1A|1<<OCIE1B|0<<TOIE1)	;INT fr ICP=off, OCIE1A=off, OCIE1B=off, OVFL=1
		out			TIMSK,temp0						
		ret

mode12_T1_init:;CTC OCR1A h:l,ICRh:l update sofort oder im INT
		;rcall		A_ch_en						;out aktivieren
		;rcall		B_ch_en						;out aktivieren
		;rcall		A_ch_load					;Zeitwert laden
		;rcall		B_ch_load					;Zeitwert laden
		ldi			temp0,(1<<WGM13|1<<WGM12)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1B,temp0	
		in			temp0,TCCR1A
		ori			temp0,(0<<COM1A1|1<<COM1A0|0<<COM1B1|1<<COM1B0|0<<WGM11|0<<WGM10)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1A,temp0
		in			temp0,TIMSK
		ori			temp0,(1<<TICIE1|0<<OCIE1A|0<<OCIE1B|0<<TOIE1)	;INT fr ICP=off, OCIE1A=off, OCIE1B=off, OVFL=1
		out			TIMSK,temp0						
		ret

mode13_T1_init:;RESERVED not activated
	/*	;rcall		A_ch_en						;out aktivieren
		;rcall		B_ch_en						;out aktivieren
		;rcall		A_ch_load					;Zeitwert laden
		;rcall		B_ch_load					;Zeitwert laden
		ldi			temp0,(1<<WGM13|1<<WGM12)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1B,temp0	
		in			temp0,TCCR1A
		ori			temp0,(1<<COM1A1|0<<COM1A0|1<<COM1B1|0<<COM1B0|0<<WGM11|1<<WGM10)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1A,temp0
		in			temp0,TIMSK
		ori			temp0,(0<<TICIE1|1<<OCIE1A|1<<OCIE1B|0<<TOIE1)	;INT fr ICP=off, OCIE1A=off, OCIE1B=off, OVFL=1
		out			TIMSK,temp0						
	*/	ret

mode14_T1_init:;FAST PWM OCR1A h:l,ICRh:l update ocrxH:L on bottom oder im INT
		;rcall		A_ch_en						;out aktivieren
		;rcall		B_ch_en						;out aktivieren
		;rcall		A_ch_load					;Zeitwert laden
		;rcall		B_ch_load					;Zeitwert laden
		ldi			temp0,(1<<WGM13|1<<WGM12)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1B,temp0	
		in			temp0,TCCR1A
		ori			temp0,(1<<COM1A1|0<<COM1A0|1<<COM1B1|0<<COM1B0|1<<WGM11|0<<WGM10)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1A,temp0
		in			temp0,TIMSK
		ori			temp0,(1<<TICIE1|0<<OCIE1A|0<<OCIE1B|0<<TOIE1)	;INT fr ICP=off, OCIE1A=off, OCIE1B=off, OVFL=1
		out			TIMSK,temp0						
		ret

mode15_T1_init:;FAST PWM OCR1A h:l,OCRah:l update ocrxH:L on bottom oder im INT
		;rcall		A_ch_en						;out aktivieren
		;rcall		B_ch_en						;out aktivieren
		;rcall		A_ch_load					;Zeitwert laden
		;rcall		B_ch_load					;Zeitwert laden
		ldi			temp0,(1<<WGM13|1<<WGM12)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1B,temp0	
		in			temp0,TCCR1A
		ori			temp0,(1<<COM1A1|0<<COM1A0|1<<COM1B1|0<<COM1B0|1<<WGM11|1<<WGM10)	;zum Toggeln COM1xA/B Einstellungen beachten!!!!!!!!!
		out			TCCR1A,temp0
		in			temp0,TIMSK
		ori			temp0,(0<<TICIE1|1<<OCIE1A|1<<OCIE1B|0<<TOIE1)	;INT fr ICP=off, OCIE1A=off, OCIE1B=off, OVFL=1
		out			TIMSK,temp0						
		ret

prescaler_T1_on:
		in			temp0,TCCR1B
		ori			temp0,(1<<CS12|1<<CS11|1<<CS10) ;schmeit den counter an
		out			TCCR1B,temp0
		sei
		ret

prescaler_T1_off:
		in			temp0,TCCR1B
		andi		temp0,(0<<CS12|0<<CS11|0<<CS10) ;stoppt den counter an
		out			TCCR1B,temp0
		ret

;**********Channel load 
A_ch_load:
		ldi			temp0,$9c		;Toggeln oder Clr/Set aktiv muss OCR1Ah-Register beachtet werden um
		sts			OCRa1h,temp0	;____--- oder _------ zu erreichen
		out			OCR1ah,temp0
		ldi			temp0,$40		;Toggeln oder Clr/Set aktiv muss OCR1Al-Register beachtet werden um
		sts			OCRa1l,temp0	;____--- oder _------ zu erreichen
		out			OCR1al,temp0
		ret

A_ch_en:sbi			ddrb,1			;output aktivieren wenn Toggeln am PINB1=OCR1A erwnscht
		ret

A_ch_dis:
		cbi			ddrb,1			;output deaktivieren wenn Toggeln am PINB1=OCR1A erwnscht
		ret

B_ch_load:
		ldi			temp0,$00		;Toggeln oder Clr/Set aktiv muss OCR1Bh-Register beachtet werden um
		sts			OCRb1h,temp0	;____--- oder _------ zu erreichen
		out			OCR1bh,temp0
		ldi			temp0,$80		;Toggeln oder Clr/Set aktiv muss OCR1Bl-Register beachtet werden um
		sts			OCRb1l,temp0	;____--- oder _------ zu erreichen
		out			OCR1bh,temp0
		ret

B_ch_en:sbi			ddrb,2			;output aktivieren wenn Toggeln am PINB1=OCR1A erwnscht
		ret

B_ch_dis:
		cbi			ddrb,2			;output deaktivieren wenn Toggeln am PINB1=OCR1A erwnscht
		ret

T1_clr:	
		clr			temp0
		out			TCNT1h,temp0
		out			TCNT1l,temp0
		ret

;**********ISR
INT_ICP1: ;$0005 Timer/Counter1 Capture Event
		;ICRH:L wird vom Counter TVCNT1H:L bei Steigender/Fallender Flanke beschrieben
		reti

INT_OC1A: ;$0006 Timer/Counter1 Compare Match A
		set
		;push		temp0
		;lds			temp0,OCRa1h		;Toggeln oder Clr/Set aktiv muss OCR1Ah-Register beachtet werden um
		;out			OCR1Ah,temp0	;____--- oder _------ zu erreichen
		;lds			temp0,OCRa1l		;Toggeln oder Clr/Set aktiv muss OCR1Al-Register beachtet werden um
		;out			OCR1Al,temp0	;____--- oder _------ zu erreichen
		;pop			temp0
		reti

INT_OC1B: ;$0007 Timer/Counter1 Compare Match B
		push		temp0
		lds			temp0,OCRb1h		;Toggeln oder Clr/Set aktiv muss OCR1Bh-Register beachtet werden um
		out			OCR1Bh,temp0	;____--- oder _------ zu erreichen
		lds			temp0,OCRb1l		;Toggeln oder Clr/Set aktiv muss OCR1Bl-Register beachtet werden um
		out			OCR1Bl,temp0	;____--- oder _------ zu erreichen
		pop			temp0
		reti

INT_OVF1: ;$0008 Timer/Counter1 Overflow
		reti

;*******************************************************************************************************************
;******************************Init-Modes des Timers2***************************************************************
mode0_T2_init:;NORMAL_MODE  OCR2 update sofort oder im INT
		;sbi			ddrb,3			;output aktivieren wenn Toggeln am PINB3=OCR2 erwnscht
		;ldi			temp0,$80		;Toggeln oder Clr/Set aktiv muss OCR2-Register beachtet werden um
		;out			OCR2,temp0		;____--- oder _------ zu erreichen
		in			temp0,TIMSK
		ori			temp0,(0<<OCIE2|1<<TOIE2)	;TimerOvfl-Int aktivieren
		out			TIMSK,temp0
		ldi			temp0,(0<<WGM21|0<<WGM20|0<<COM21|0<<COM20)	;zum Toggeln COM2x Einstellungen beachten!!!!!!!!!
		out			TCCR2,temp0									;
		ret

mode1_T2_init:;PWM-PhaseCorrect kein toggeln mglich nur Clear/Set, bei erreichen TOP = OCR2 update
		sbi			ddrb,3			;output aktivieren
		ldi			temp0,$80		;zum Clr/Set muss OCR2-Register beachtet werden um
		out			OCR2,temp0		;____--- oder _------ zu erreichen
		in			temp0,TIMSK
		ori			temp0,(0<<OCIE2|0<<TOIE2);OutputCompareInterrupt deaktiviert
		out			TIMSK,temp0
		ldi			temp0,(0<<WGM21|1<<WGM20|1<<COM21|0<<COM20)	;zum Toggeln COM2x Einstellungen beachten!!!!!!!!!
		out			TCCR2,temp0
		ret
		
mode2_T2_init:;CTC = nonPwm = toggeln mglich OCR2 update sofort oder im INT
		sbi			ddrb,3			;output aktivieren
		ldi			temp0,$13		;Toggeln oder Clr/Set aktiv muss OCR2-Register beachtet werden um
		out			OCR2,temp0		;________-------- oder ____---- zu erreichen
		sts			OCR2s,temp0
		in			temp0,TIMSK
		ori			temp0,(1<<OCIE2|0<<TOIE2);OutputCompareInterrupt deaktiviert					
		out			TIMSK,temp0
		ldi			temp0,(1<<WGM21|0<<WGM20|0<<COM21|1<<COM20)	;zum Toggeln COM2x Einstellungen beachten!!!!!!!!!
		out			TCCR2,temp0
		ret
		
mode3_T2_init:;FastPWM kein toggeln mglich nur Clear/Set, bei erreichen BOTTOM = OCR2 update
		sbi			ddrb,3			;output aktivieren
		ldi			temp0,$e0		;zum Clr/Set muss OCR2-Register beachtet werden um
		out			OCR2,temp0		;____--- oder _------ zu erreichen		
		sts			OCR2s,temp0
		in			temp0,TIMSK
		ori			temp0,(1<<OCIE2|0<<TOIE2);OutputCompareInterrupt deaktiviert
		out			TIMSK,temp0
		ldi			temp0,(1<<WGM21|1<<WGM20|1<<COM21|0<<COM20)	;zum Toggeln COM2x Einstellungen beachten!!!!!!!!!
		out			TCCR2,temp0
		ret

prescaler_T2_on:
		in			temp0,TCCR2
		ori			temp0,(1<<CS22|1<<CS21|0<<CS20) ;schmeit den counter an
		out			TCCR2,temp0
		sei
		ret

prescaler_T2_off:
		in			temp0,TCCR2
		andi		temp0,(0<<CS22|0<<CS21|0<<CS20) ;stoppt den counter an
		out			TCCR2,temp0
		ret

T2_clr:	clr			temp0
		out			TCNT2,temp0
		ret

INT_OC2: ;$0003
		push		temp1
		lds			temp1,ocr2s
		out			ocr2,temp1
		pop			temp1
		reti

INT_OVF2: ;$0004
		reti
